mtype = {RED, GREEN};

bool ped_semaphore_green = false;
bool car_semaphore_green = true;

proctype pedestrian(chan out)
{

    do
    /* non-deterministic choice of crossing the road */
    ::true -> skip;
    ::out!GREEN ->
waiting_l:
        printf("Pedestrian: Waiting for green\n");

        /* block until pedestrian semaphore becomes green */
        ped_semaphore_green;
crossing_l:
        /* crossing the road, when I am done  */
        printf("Pedestrian: Crossing\n");
        do
            ::true -> skip;
            ::out!RED -> break;
        od;
        printf("Pedestrian: Done\n");
    od;
}

proctype pedestrian_semaphore(chan in_ped, out)
{
    do
        ::in_ped?GREEN ->
              printf("Ped Semaphore: wait car sem to red\n");
              /* ask the car semaphore to switch to RED */
              out!RED;
              /* wait for the semaphore to switch */
             !car_semaphore_green;
             /* switch to green */
ped_sem_green_l:
             printf("Ped Semaphore: GREEN, wait crossing\n");
             ped_semaphore_green = true;
             /* wait for pedestrian to cross */
             in_ped?RED;
             /* switch to RED */
ped_sem_red_l:
             printf("Ped Semaphore: RED\n");
             ped_semaphore_green = false;
             /* allow car semaphore to switch to green */
             out!GREEN;
    od;
}

proctype car_semaphore(chan in)
{
    do
        ::in?RED ->
car_semaphore_red:
              printf("Car semaphore to RED\n");
              car_semaphore_green = false;
              /* wait permission to switch back to green */
              in?GREEN;
car_semaphore_green_l:
              car_semaphore_green = true;
    od;
}


init {
    chan ped_to_semaphore = [0] of {mtype};
    chan sem_to_sem = [0] of {mtype};
    run pedestrian(ped_to_semaphore);
    run pedestrian_semaphore(ped_to_semaphore, sem_to_sem);
    run car_semaphore(sem_to_sem);
}

ltl p1 { [] !(ped_semaphore_green & car_semaphore_green) }
ltl p2 { ([]<> _last == 1) -> ([]<> pedestrian[0]@crossing_l) }
